PrettyPrinter
Date: 2016-12-03

com.fasterxml.jackson.core

## Interface PrettyPrinter

- All Known Implementing Classes:
    DefaultPrettyPrinter, MinimalPrettyPrinter

      public interface PrettyPrinter

  Interface for objects that implement pretty printer functionality, such as indentation. Pretty printers are used to add white space in output JSON content, to make results more human readable. Usually this means things like adding linefeeds and indentation.

  Note: since Jackson 2.1, stateful implementations MUST implement `Instantiatable` interface, to allow for constructing per-generation instances and avoid state corruption (see [JACKSON-851] for details). Stateless implementations need not do this; but those are less common.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `beforeArrayValues(JsonGenerator gen)` Method called after array start marker has been output, and right before the first value is to be output.
    `void` | `beforeObjectEntries(JsonGenerator gen)` Method called after object start marker has been output, and right before the field name of the first entry is to be output.
    `void` | `writeArrayValueSeparator(JsonGenerator gen)` Method called after an array value has been completely output, and before another value is to be output.
    `void` | `writeEndArray(JsonGenerator gen, int nrOfValues)` Method called after an Array value has been completely output (minus closing bracket).
    `void` | `writeEndObject(JsonGenerator gen, int nrOfEntries)` Method called after an Object value has been completely output (minus closing curly bracket).
    `void` | `writeObjectEntrySeparator(JsonGenerator gen)` Method called after an object entry (field:value) has been completely output, and before another value is to be output.
    `void` | `writeObjectFieldValueSeparator(JsonGenerator gen)` Method called after an object field has been output, but before the value is output.
    `void` | `writeRootValueSeparator(JsonGenerator jg)` Method called after a root-level value has been completely output, and before another value is to be output.
    `void` | `writeStartArray(JsonGenerator gen)` Method called when an Array value is to be output, before any member/child values are output.
    `void` | `writeStartObject(JsonGenerator gen)` Method called when an Object value is to be output, before any fields are output.

- - ### Method Detail

    - #### writeRootValueSeparator

          void writeRootValueSeparator(JsonGenerator jg)
                                       throws java.io.IOException,
                                              JsonGenerationException

      Method called after a root-level value has been completely output, and before another value is to be output.

      Default handling (without pretty-printing) will output a space, to allow values to be parsed correctly. Pretty-printer is to output some other suitable and nice-looking separator (tab(s), space(s), linefeed(s) or any combination thereof).

      Throws:
        `java.io.IOException`
        `JsonGenerationException`

    - #### writeStartObject

          void writeStartObject(JsonGenerator gen)
                                throws java.io.IOException,
                                       JsonGenerationException

      Method called when an Object value is to be output, before any fields are output.

      Default handling (without pretty-printing) will output the opening curly bracket. Pretty-printer is to output a curly bracket as well, but can surround that with other (white-space) decoration.

      Throws:
        `java.io.IOException`
        `JsonGenerationException`

    - #### writeEndObject

          void writeEndObject(JsonGenerator gen,
                            int nrOfEntries)
                              throws java.io.IOException,
                                     JsonGenerationException

      Method called after an Object value has been completely output (minus closing curly bracket).

      Default handling (without pretty-printing) will output the closing curly bracket. Pretty-printer is to output a curly bracket as well, but can surround that with other (white-space) decoration.

      Parameters:
        `nrOfEntries` - Number of direct members of the array that have been output
      Throws:
        `java.io.IOException`
        `JsonGenerationException`

    - #### writeObjectEntrySeparator

          void writeObjectEntrySeparator(JsonGenerator gen)
                                         throws java.io.IOException,
                                                JsonGenerationException

      Method called after an object entry (field:value) has been completely output, and before another value is to be output.

      Default handling (without pretty-printing) will output a single comma to separate the two. Pretty-printer is to output a comma as well, but can surround that with other (white-space) decoration.

      Throws:
        `java.io.IOException`
        `JsonGenerationException`

    - #### writeObjectFieldValueSeparator

          void writeObjectFieldValueSeparator(JsonGenerator gen)
                                              throws java.io.IOException,
                                                     JsonGenerationException

      Method called after an object field has been output, but before the value is output.

      Default handling (without pretty-printing) will output a single colon to separate the two. Pretty-printer is to output a colon as well, but can surround that with other (white-space) decoration.

      Throws:
        `java.io.IOException`
        `JsonGenerationException`

    - #### writeStartArray

          void writeStartArray(JsonGenerator gen)
                               throws java.io.IOException,
                                      JsonGenerationException

      Method called when an Array value is to be output, before any member/child values are output.

      Default handling (without pretty-printing) will output the opening bracket. Pretty-printer is to output a bracket as well, but can surround that with other (white-space) decoration.

      Throws:
        `java.io.IOException`
        `JsonGenerationException`

    - #### writeEndArray

          void writeEndArray(JsonGenerator gen,
                           int nrOfValues)
                             throws java.io.IOException,
                                    JsonGenerationException

      Method called after an Array value has been completely output (minus closing bracket).

      Default handling (without pretty-printing) will output the closing bracket. Pretty-printer is to output a bracket as well, but can surround that with other (white-space) decoration.

      Parameters:
        `nrOfValues` - Number of direct members of the array that have been output
      Throws:
        `java.io.IOException`
        `JsonGenerationException`

    - #### writeArrayValueSeparator

          void writeArrayValueSeparator(JsonGenerator gen)
                                        throws java.io.IOException,
                                               JsonGenerationException

      Method called after an array value has been completely output, and before another value is to be output.

      Default handling (without pretty-printing) will output a single comma to separate the two. Pretty-printer is to output a comma as well, but can surround that with other (white-space) decoration.

      Throws:
        `java.io.IOException`
        `JsonGenerationException`

    - #### beforeArrayValues

          void beforeArrayValues(JsonGenerator gen)
                                 throws java.io.IOException,
                                        JsonGenerationException

      Method called after array start marker has been output, and right before the first value is to be output. It is not called for arrays with no values.

      Default handling does not output anything, but pretty-printer is free to add any white space decoration.

      Throws:
        `java.io.IOException`
        `JsonGenerationException`

    - #### beforeObjectEntries

          void beforeObjectEntries(JsonGenerator gen)
                                   throws java.io.IOException,
                                          JsonGenerationException

      Method called after object start marker has been output, and right before the field name of the first entry is to be output. It is not called for objects without entries.

      Default handling does not output anything, but pretty-printer is free to add any white space decoration.

      Throws:
        `java.io.IOException`
        `JsonGenerationException`